#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "dictionary.h"

/* Calculate the edition distance between two strings */
int getDistance(char* ref,char* word) {
	char* w1=NULL;
	char* w2=NULL;
	int dist=0;
	int i=0;
	bool different=false;
	
	/* Put the shortest word on w1 and the longest on w2. */
	if(strlen(ref)<=strlen(word)) {
		w1=ref;
		w2=word;
	} else {
		w1=word;
		w2=ref;
	}
	
	/* Copare char to char */
	for(i=0;i<strlen(w2);i++) {
		
		if(different) {
			/* If the words are different, increase the distance */
			dist++;
		} else {
			/* Compare the new char and word lenghts */
			if(i<strlen(w1)) {
				different=w1[i]!=w2[i];
			} else {
				/* w1 is shorter than w2 */
				different=true;
			}
			if(different) {
				/* If the words are different, increase the distance */
				dist++;
			}
		}
	}
	
	return dist;
}

/* Get word information */
bool getWordInfo(char* str,char* word,int* languageID,int* wordID) {
	*languageID=-1;
	*wordID=-1;
	sscanf(str,"%s ; %d ; %d",word,languageID,wordID);
	return *languageID>0 && *wordID>0;
}
